package boundary;

import java.awt.Rectangle;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import control.TeacherControl;

public class TeacherGUI extends JFrame {

	private TeacherControl teacherControl;
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton jButtonLoad = null;
	private JButton jButtonSave = null;
	private JButton jButtonAdd = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel11 = null;
	private JLabel jLabel111 = null;
	private JLabel jLabel1111 = null;
	private JTextField jTextFieldFirstName = null;
	private JTextField jTextFieldLastName = null;
	private JTextField jTextFieldEmail = null;
	private JTextField jTextFieldRoom = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextAreaOutput = null;

	/**
	 * This is the default constructor
	 */
	public TeacherGUI() {
		super();
		initialize();
		teacherControl = new TeacherControl();
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(517, 286);
		this.setContentPane(getJContentPane());
		this.setTitle("Teacher System");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel1111 = new JLabel();
			jLabel1111.setBounds(new Rectangle(330, 150, 61, 16));
			jLabel1111.setHorizontalAlignment(SwingConstants.TRAILING);
			jLabel1111.setText("room");
			jLabel111 = new JLabel();
			jLabel111.setBounds(new Rectangle(330, 120, 61, 16));
			jLabel111.setHorizontalAlignment(SwingConstants.TRAILING);
			jLabel111.setText("email");
			jLabel11 = new JLabel();
			jLabel11.setBounds(new Rectangle(330, 90, 61, 16));
			jLabel11.setHorizontalAlignment(SwingConstants.TRAILING);
			jLabel11.setText("last name");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new Rectangle(330, 60, 61, 16));
			jLabel1.setHorizontalAlignment(SwingConstants.TRAILING);
			jLabel1.setText("first name");
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(360, 15, 136, 28));
			jLabel.setHorizontalAlignment(SwingConstants.TRAILING);
			jLabel.setText("Add new teacher");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJButtonLoad(), null);
			jContentPane.add(getJButtonSave(), null);
			jContentPane.add(getJButtonAdd(), null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(jLabel11, null);
			jContentPane.add(jLabel111, null);
			jContentPane.add(jLabel1111, null);
			jContentPane.add(getJTextFieldFirstName(), null);
			jContentPane.add(getJTextFieldLastName(), null);
			jContentPane.add(getJTextFieldEmail(), null);
			jContentPane.add(getJTextFieldRoom(), null);
			jContentPane.add(getJScrollPane(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jButtonLoad	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonLoad() {
		if (jButtonLoad == null) {
			jButtonLoad = new JButton();
			jButtonLoad.setBounds(new Rectangle(15, 210, 91, 31));
			jButtonLoad.setText("Load");
			jButtonLoad.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					jTextAreaOutput.setText(teacherControl.retrieveTeachers());
					jButtonSave.setEnabled(true);
					jButtonAdd.setEnabled(true);
				}
			});
		}
		return jButtonLoad;
	}

	/**
	 * This method initializes jButtonSave	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSave() {
		if (jButtonSave == null) {
			jButtonSave = new JButton();
			jButtonSave.setBounds(new Rectangle(120, 210, 91, 31));
			jButtonSave.setText("Save");
			jButtonSave.setEnabled(false);
			jButtonSave.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					teacherControl.SaveTeachers();
				}
			});
		}
		return jButtonSave;
	}

	/**
	 * This method initializes jButtonAdd	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAdd() {
		if (jButtonAdd == null) {
			jButtonAdd = new JButton();
			jButtonAdd.setBounds(new Rectangle(405, 210, 91, 31));
			jButtonAdd.setText("Add");
			jButtonAdd.setEnabled(false);
			jButtonAdd.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					jTextAreaOutput.setText(teacherControl.createNewTeacher
							(jTextFieldFirstName.getText(),
							jTextFieldLastName.getText(),
							jTextFieldEmail.getText(),
							Integer.parseInt(jTextFieldRoom.getText())));
				}
			});
		}
		return jButtonAdd;
	}

	/**
	 * This method initializes jTextFieldFirstName	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldFirstName() {
		if (jTextFieldFirstName == null) {
			jTextFieldFirstName = new JTextField();
			jTextFieldFirstName.setBounds(new Rectangle(405, 60, 91, 16));
		}
		return jTextFieldFirstName;
	}

	/**
	 * This method initializes jTextFieldLastName	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldLastName() {
		if (jTextFieldLastName == null) {
			jTextFieldLastName = new JTextField();
			jTextFieldLastName.setBounds(new Rectangle(405, 90, 91, 16));
		}
		return jTextFieldLastName;
	}

	/**
	 * This method initializes jTextFieldEmail	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldEmail() {
		if (jTextFieldEmail == null) {
			jTextFieldEmail = new JTextField();
			jTextFieldEmail.setBounds(new Rectangle(405, 120, 91, 16));
		}
		return jTextFieldEmail;
	}

	/**
	 * This method initializes jTextFieldRoom	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRoom() {
		if (jTextFieldRoom == null) {
			jTextFieldRoom = new JTextField();
			jTextFieldRoom.setBounds(new Rectangle(405, 150, 91, 16));
		}
		return jTextFieldRoom;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(15, 15, 286, 181));
			jScrollPane.setViewportView(getJTextAreaOutput());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextAreaOutput	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextAreaOutput() {
		if (jTextAreaOutput == null) {
			jTextAreaOutput = new JTextArea();
		}
		return jTextAreaOutput;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
