package control;

import java.util.ArrayList;
import java.util.Scanner;

import boundary.FileIO;
import entity.Teacher;

public class TeacherControl
{
	private ArrayList <Teacher> teachers;
	private FileIO fileIO;
	
	public TeacherControl()
	{
		fileIO = new FileIO();
		teachers = new ArrayList<Teacher>();
	}
	
	public String createNewTeacher(String firstName, String lastName, String email, int roomNumber)
	{
		teachers.add(new Teacher(firstName, lastName, email, roomNumber));
		return transformTeacherArrayListToString();
	}
	
	public void createTeachers()
	{
		ArrayList <String >teachersText = new ArrayList<String>();
		teachersText = fileIO.readFromTextFile();
		Scanner scan;
		String firstName = "", lastName = "", email = "";
		int roomNumber = 0;
		Teacher teacher;
		int size = teachersText.size();
		for (int i = 0; i < size; i++)
		{
			scan = new Scanner(teachersText.get(i));
			scan.useDelimiter(", ");
			if(scan.hasNext())
			{
				firstName = scan.next();
			}
			if(scan.hasNext())
			{
				lastName = scan.next();
			}
			if(scan.hasNext())
			{
				email = scan.next();
			}
			if(scan.hasNext())
			{
				roomNumber = Integer.parseInt(scan.next());
			}
			
			teacher = new Teacher (firstName, lastName, email, roomNumber);
			teachers.add(teacher);
		}
	}
	
	public void SaveTeachers()
	{
		fileIO.writeToBinFile(teachers);
	}
	
	public String retrieveTeachers()
	{
		String result = "";
		try
		{
			teachers = fileIO.readFromBinFile();
		}
		catch(Exception e)
		{
			System.out.println("Something went wrong while reading to bin file!!");
			System.out.println(e);
			System.out.println(e.getMessage());	
			createTeachers();
		}
		result = transformTeacherArrayListToString();
		return result;
	}
	
	private String transformTeacherArrayListToString()
	{
		String result = "";
		int size = teachers.size();
		for (int i = 0; i < size; i++)
		{
			result += teachers.get(i).toString();
		}
		return result;
		
	}
}

